﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ctxt As JavaObject
	Private Storage As ExternalStorage
	Private Chooser As ContentChooser
	Private PCLV As PreoptimizedCLV
	Private CLV1 As CustomListView
	Private Jb As HttpJob
	Private CF As CheckBox
	Private JukeBox As SimpleExoPlayerView
	Private streamer As AudioStreamer
	Private Player1 As SimpleExoPlayer
	Private TTS1 As TTS
	Private recordingStart, playingstart As Long
	Private buffers As List
	Private timer1, timer2 As Timer
	Private ClipTime As Int
	Private mBitRate As Int = 16
	Private mSampleRate As Int = 22050
	Private mMono As Boolean = True
	Dim Label1, Label2, Label3 As B4XView
	Dim btnSR, btnPlay, btnSave, btnStop, PlayList As B4XView
	Public FileName As String
	Private rp As RuntimePermissions
	Private cStoragePath, DestinationFile, FolderStack As ExternalFile
	Private IN As InputStream, OUT As OutputStream
	Public StartUp As Boolean = False
	Private FoldersStack As List
	Private UpItem As ExternalFile
	Public SongName, SongLineName As String
	Public FirstTime As Boolean = False
	Public ListSongName As List
	Public MP As MediaPlayer
	Public mFileName As String
	Private Output As OutputStream
	Private Recording As Boolean
	Private ClipTime As Int
End Sub

Public Sub Initialize
	streamer.Initialize("streamer", mSampleRate, mMono, mBitRate, streamer.VOLUME_MUSIC)
	Storage.Initialize(Me,"Storage")
	Jb.Initialize("",Me)
	CF.Initialize("")
	buffers.Initialize
	Player1.Initialize("Player")
	timer1.Initialize("timer1", 1000)
	timer2.Initialize("timer2", 1000)
	FolderStack.Initialize
	Chooser.Initialize("chooser") 
	If TTS1.IsInitialized = False Then
		TTS1.Initialize("TTS1")
	End If
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Recorder")
	PCLV.Initialize(Me, "PCLV", CLV1)
	FoldersStack.Initialize
	ctxt.InitializeContext
	Label3.Text = "▲ Start and stop ▲ " & CRLF & "a sound recording"
	PlayList.Text = "View existing recordings and listen to sound files" & CRLF & "Small mp3 or wav files can be played in the app"
	PlayList.Text = PlayList.Text & CRLF & "other files can be read by your own applications " & CRLF & "Long press the name of the file you want to listen to."
	MP.Initialize2("MP")
	Depart
End Sub


Private Sub Depart
	Msgbox2Async("Do you want to create a folder for sound recordings? ?", "Create new folder ?", "Yes", "", "No", Null, True)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.POSITIVE Then
		CreateNewDir
	Else
		FirstTime = False
		PlayList.Visible = True
		PlayList.Enabled = True
	End If
End Sub

Sub CreateNewDir
	Label1.Text="Please wait while the music files are copied and downloaded"
	Storage.SelectDir(CF.Checked)
	Wait For Storage_ExternalFolderAvailable
	' Find a file on external storage or create it
		cStoragePath = Storage.Root
		
		'Installing a cookie File IN external Storage
		
		FileName = "CookieFile.txt"
		CopyFileToExternalStorage(File.DirAssets, FileName, Storage.root, "")
		Log (FileName & " a été créé")
		
		'1- Copies of the 3 internal music files in the directory chosen by the user
		
		Log("First phase: Copying tree internal files to external storage")
		FileName = "Entertainer.wav"
		CopyFileToExternalStorage(File.DirAssets, FileName, Storage.root, "")
		FileName = "Jambalaya.mid"
		CopyFileToExternalStorage(File.DirAssets, FileName, Storage.root, "")
		FileName = "DorisDAY.flac"
		CopyFileToExternalStorage(File.DirAssets, FileName, Storage.root, "")
		
		'2- Copying two downloaded music files to the directory chosen by the user
		Log("Second phase: download and copy")
		
		FileName="Sample.mp3"
		Jb.Download("https://www.marcalaindaniel.fr/MusicBoxPlayer/Sample.mp3")
		Jb.GetRequest.Timeout = 100000
		wait for (Jb)Jobdone
		If Jb.Success Then
			Log("Good News ! Download was successful : " & FileName)
			IN = Jb.GetInputStream
			DestinationFile = Storage.CreateNewFile(cStoragePath,"Sample.mp3")
			OUT = Storage.OpenOutputStream(DestinationFile)
			File.Copy2(IN, OUT)
			OUT.Close
			IN.Close
			Log("All files have been copied to external storage !")
			Jb.release
		Else
		Log("Bad News ! Download was not successful : " & FileName)
	End If
	
	
	FileName="Primavera.mp3"
	Jb.Download("https://www.marcalaindaniel.fr/MusicBoxPlayer/Primavera.mp3")
	Jb.GetRequest.Timeout = 100000
	wait for (Jb)Jobdone
	If Jb.Success Then
		Log("Good News ! Download was successful : " & FileName)
		IN = Jb.GetInputStream
		DestinationFile = Storage.CreateNewFile(cStoragePath,"Primavera.mp3")
		OUT = Storage.OpenOutputStream(DestinationFile)
		File.Copy2(IN, OUT)
		OUT.Close
		IN.Close
		Log("All files have been copied to external storage !")
		Jb.release
	Else
		Log("Bad News ! Download was not successful : " & FileName)
	End If
	Sleep(9000)
	Label1.Text = ""
	MsgboxAsync("Congratulations, you have successfully created your directory for recordings. Three internal music files have been copied into it as well as two music files downloaded from the web.","User Directory Selection")
	PlayList.Visible = True
	PlayList.Enabled = True
	FirstTime = True
End Sub


Public Sub CopyFileToExternalStorage (Dir As String, Name As String, Parent As ExternalFile, Rename As String) As Boolean
   If File.Exists(Dir, FileName) = False Then
        Log("Bad News ! File do not exist while copy to External Storage: " & FileName)
        Return False
    End If
	Log("Good News ! File exist while copy to External Storage! : " & FileName)
    Dim iStream As InputStream, oStream As OutputStream
    Dim oFile As ExternalFile
 
    If Rename <> "" Then
        oFile = Storage.FindFileOrCreate(Parent, "")  ' Optionally rename output file, pass "" to Rename argument will mantain original name
    Else
        oFile = Storage.FindFileOrCreate(Parent, Name)
    End If
 
    If oFile.IsInitialized Then
        iStream = File.OpenInput(Dir, FileName)
        oStream = Storage.OpenOutputStream(oFile)
        File.copy2(iStream, oStream)
        iStream.Close
        oStream.Close
        Return True
    Else
        Log("Cannot create file on External Storage: " & FileName)
        Return False
    End If
End Sub




Private Sub Timer1_Tick
	Label1.Text = "Recording: " & _
		Round((DateTime.Now - recordingStart) / DateTime.TicksPerSecond) & " seconds"
End Sub

Private Sub Timer2_Tick
	Label1.Text = "Playing: " & _
		Round((DateTime.Now - playingstart) / DateTime.TicksPerSecond)& " out of " & ClipTime & " seconds"
End Sub

Sub PlayList_Click
	CLV1.Clear
	PCLV.NumberOfSteps = 50
	PCLV.lblHint.Font = xui.CreateDefaultBoldFont(20)
	PCLV.lblHint.TextColor = xui.Color_Black
	If FirstTime = True Then
		EnterFolder(cStoragePath)
		Else
		Storage.SelectDir(True)
		Wait For Storage_ExternalFolderAvailable
		If (Storage.Root.IsFolder And Storage.Root.Name <> "")Then
			EnterFolder(Storage.Root)
		End If
	End If
End Sub


Private Sub EnterFolder (folder As ExternalFile)
	Dim n As Int
	ListSongName.Initialize
	FoldersStack.Clear
	CLV1.Clear
	If FoldersStack.Size > 1 Then
		CLV1.AddTextItem("..", UpItem)
	End If
	For Each f As ExternalFile In Storage.ListFiles(folder)
		n = n + 1
		If f.IsFolder Then
		Else If IsMusicFile(f.Name) Then
			Dim cs As CSBuilder
			cs.Initialize.Append(f.Name).PopAll
			ListSongName.Add(f.Name)
			Log (f.Name)
			CLV1.AddTextItem(cs, f)
		End If
	Next
	PCLV.Commit
	PCLV.B4XSeekBar1.Value = CLV1.Size - 1
End Sub

Sub CLV1_ItemLongClick(Index As Int, Value As Object)
	Dim MusicGenre As Int
	Dim suffix As String, ls As Int
	SongName = ListSongName.Get(Index)
	Storage.FindFile(Storage.Root,SongName)
	ls = SongName.length
	suffix = SongName.SubString2(ls-3, ls)
	Log ("Suffix = " & suffix)
	Log ("File Name = " & SongName)
	
	If SongName.EndsWith(".mp3") Or SongName.EndsWith(".MP3")Then MusicGenre = 1
	If SongName.EndsWith(".wav") Or SongName.EndsWith(".WAV")Then MusicGenre = 1
	If SongName.EndsWith(".flac") Or SongName.EndsWith(".FLAC")Then MusicGenre = 1 
	If SongName.EndsWith(".mid") Then MusicGenre = 2
	If SongName.EndsWith(".gp3") Then MusicGenre = 3
	
	Select MusicGenre
		Case 1
			'Playing the sound files in the application
			If File.Exists(File.DirInternal, SongName) = False Then
				Dim iStream As InputStream, oStream As OutputStream
				Dim oFile As ExternalFile

				oFile = Storage.FindFileOrCreate(Storage.Root, SongName)

				If oFile.IsInitialized Then
					iStream = Storage.OpenInputStream(oFile)
					oStream = File.OpenOutput(File.DirInternal, SongName, False)
					File.copy2(iStream, oStream)
					iStream.Close
					oStream.Close
				End If
			End If
			Player1.Prepare(Player1.CreateFileSource(File.DirInternal,SongName))
			JukeBox.Player = Player1
			Label1.Text = " Music Title: " & SongName
			Player1.Play
			
		
		Case Else
			
			'Play sound files outside the app through your own devices
			
			Chooser.Show("audio/*", "Choose audio file")
			Wait For Chooser_Result (Success1 As Boolean, Dir1 As String, FileName1 As String)
			If Success1 Then
				Dim InStr As InputStream = File.OpenInput("ContentDir",FileName1)
				Dim OutStr As OutputStream = File.OpenOutput(File.DirInternal, SongName,False)
				File.Copy2(InStr,OutStr)
				OutStr.Close
			Else
				MsgboxAsync("If your music file is not playing," & CRLF & "you can open it directly outside" & CRLF & "this application by opening the"& CRLF & "folder chosen by you in the" & CRLF & "external storage","Advice")
			End If
		
	End Select
	
End Sub


Private Sub IsMusicFile (Name As String) As Boolean
	Dim n As String = Name.ToLowerCase
	For Each extension As String In Array("3gp", "mp3", "MP3", "flac", "FLAC", "mid", "MID", "wav", "WAV", "Wav")
		If n.EndsWith(extension) Then Return True
	Next
	Return False
End Sub

Sub StartWaveFile(Dir3 As String, FileName3 As String, SampleRate As Int, Mono As Boolean _
		, BitsPerSample As Int) As OutputStream
	File.Delete(Dir3, FileName3)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir3, FileName3, False, True)
	raf.WriteBytes("RIFF".GetBytes("ASCII"), 0, 4, raf.CurrentPosition)
	raf.CurrentPosition = 8 'skip 4 bytes for the size
	raf.WriteBytes("WAVE".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteBytes("fmt ".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(16, raf.CurrentPosition)
	raf.WriteShort(1, raf.CurrentPosition)
	Dim numberOfChannels As Int
	If Mono Then numberOfChannels = 1 Else numberOfChannels = 2
	raf.WriteShort(numberOfChannels, raf.CurrentPosition)
	raf.WriteInt(SampleRate, raf.CurrentPosition)
	raf.WriteInt(SampleRate * numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(BitsPerSample, raf.CurrentPosition)
	raf.WriteBytes("data".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(0, raf.CurrentPosition)
	raf.Close
	Return File.OpenOutput(Dir3, FileName3, True)
End Sub

Sub CloseWaveFile(Dir4 As String, FileName4 As String)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir4, FileName4, False, True)
	raf.WriteInt(raf.Size - 8, 4)
	raf.WriteInt(raf.Size - 44, 40)
	raf.Close
End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	If Recording Then Output.WriteBytes(Buffer, 0, Buffer.Length)
	'the above check is required as the last message will arrive after we call StopRecording.
End Sub


Sub btnSR_Click
	btnStop.Enabled = True
	rp.CheckAndRequest(rp.PERMISSION_RECORD_AUDIO)
	Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		xui.MsgboxAsync("No permission", "")
		Return
	Else
		mFileName = DateTime.GetYear(DateTime.Now) & "-" & DateTime.GetMonth(DateTime.Now) & "-" & DateTime.GetDayOfMonth(DateTime.Now)
		mFileName = mFileName & "-" & DateTime.Gethour(DateTime.Now) & "h" & DateTime.GetMinute(DateTime.Now) & ".wav"
		buffers.Clear
		Output = StartWaveFile(File.DirInternal, mFileName, mSampleRate, mMono, mBitRate)
		Recording = True
		streamer.StartRecording
		recordingStart = DateTime.Now
		timer1.Enabled = True
		Timer1_Tick
		btnPlay.Enabled = False
		btnSR.Enabled = False
	End If
End Sub

Sub btnStop_Click
	ClipTime =(( DateTime.Now - recordingStart) / DateTime.TicksPerSecond)
	streamer.StopRecording
	Recording = False
	Output.Close
	CloseWaveFile(File.DirInternal, mFileName)
	timer1.Enabled = False
	btnPlay.Enabled = True
	Label1.Text = ""
	btnPlay.Enabled = True
	btnPlay.Visible= True
	btnStop.Enabled = False
	btnSR.Enabled = True
End Sub

Private Sub btnPlay_Click
	MP.Load(File.DirInternal, mFileName)
	playingstart = DateTime.now
	timer2.Enabled = True
	Timer2_Tick
	MP.Play
	btnSave.Enabled = True
	btnSave.Visible= True
End Sub

Sub mp_Complete
	timer2.Enabled = False
	Log("PlaybackComplete")
	btnSR.Enabled = True
End Sub

Sub BtnSave_Click
	Msgbox2Async("Do you really want to save this sound?", "Save this sound", "Yes", "", "No", Null, True)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.POSITIVE Then
	mFileName = DateTime.GetYear(DateTime.Now) & "-" & DateTime.GetMonth(DateTime.Now) & "-" & DateTime.GetDayOfMonth(DateTime.Now)
	mFileName = mFileName & "-" & DateTime.Gethour(DateTime.Now) & "h" & DateTime.GetMinute(DateTime.Now) & ".wav"
	FileName = mFileName
	CopyFileToExternalStorage(File.DirInternal, FileName, Storage.root, "")
	btnPlay.Visible=False
	btnSave.Visible = False
	Label1.Text = "Recording: " & FileName & " on your external storage"
	Sleep(6000)
	Label1.Text = ""	
	End If
End Sub